# class Crystal::Macros::Metaclass

- Crystal::Macros::Metaclass
- Crystal::Macros::ASTNode

##
Overview

A metaclass in a type expression: `T.class`

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #instance : ASTNode

  Returns the node representing the instance type of this metaclass.

- #resolve : ASTNode

  Resolves this metaclass to a `TypeNode` if it denotes a type, or otherwise gives a compile-time error.

- #resolve? : ASTNode | NilLiteral

  Resolves this metaclass to a `TypeNode` if it denotes a type, or otherwise returns a `NilLiteral`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def instance : ASTNode #

Returns the node representing the instance type of this metaclass.

def resolve : ASTNode #

Resolves this metaclass to a `TypeNode` if it denotes a type, or otherwise gives a compile-time error.

def resolve? : ASTNode | NilLiteral #

Resolves this metaclass to a `TypeNode` if it denotes a type, or otherwise returns a `NilLiteral`.